package cn.ibizlab.businesscentral.core.sales.service.logic.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.kie.api.runtime.KieSession;
import org.kie.api.runtime.KieContainer;

import cn.ibizlab.businesscentral.core.sales.service.logic.ISalesOrderCancelLogic;
import cn.ibizlab.businesscentral.core.sales.domain.SalesOrder;

/**
 * 关系型数据实体[Cancel] 对象
 */
@Slf4j
@Service
public class SalesOrderCancelLogicImpl implements ISalesOrderCancelLogic{

    @Autowired
    private KieContainer kieContainer;

    @Autowired
    private cn.ibizlab.businesscentral.core.sales.service.ISalesOrderService salesorderservice;

    public cn.ibizlab.businesscentral.core.sales.service.ISalesOrderService getSalesorderService() {
        return this.salesorderservice;
    }


    @Autowired
    private cn.ibizlab.businesscentral.core.sales.service.ISalesOrderService iBzSysDefaultService;

    public cn.ibizlab.businesscentral.core.sales.service.ISalesOrderService getIBzSysDefaultService() {
        return this.iBzSysDefaultService;
    }

    public void execute(SalesOrder et){

          KieSession kieSession = null;
        try{
           kieSession=kieContainer.newKieSession();
           kieSession.insert(et); 
           kieSession.setGlobal("salesordercanceldefault",et);
           kieSession.setGlobal("salesorderservice",salesorderservice);
           kieSession.setGlobal("iBzSysSalesorderDefaultService",iBzSysDefaultService);
           kieSession.setGlobal("curuser", cn.ibizlab.businesscentral.util.security.AuthenticationUser.getAuthenticationUser());
           kieSession.startProcess("cn.ibizlab.businesscentral.core.sales.service.logic.salesordercancel");

        }catch(Exception e){
            throw new RuntimeException("执行[取消订单]处理逻辑发生异常"+e);
        }finally {
            if(kieSession!=null)
            kieSession.destroy();
        }
    }

}
